c Copyright (c) 2013, Dr Renato Vacondio, Dr Benedict Rogers, Prof. Peter Stansby 
c and Prof. Paolo Mignosa
c 
c All rights reserved.
c 
c This file is part of SWE-SPHYSICS.
c 
c Redistribution and use in source and binary forms, with or without modification, 
c are permitted provided that the following conditions are met:
c 
c - Redistributions of source code must retain the above copyright notice, 
c  this list of conditions and the following disclaimer.
c - Redistributions in binary form must reproduce the above copyright notice, 
c  this list of conditions and the following disclaimer in the documentation 
c  and/or other materials provided with the distribution.
c
c THE "SWE-SPHYSICS" IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
c ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
c OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
c THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
c SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
c OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
c HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR 
c TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
c EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

      subroutine ac
c
      use global_1D

      integer lx, j1, lx2, i
      real dxx

c        -- Zeroing Variables -- 
      do i=nstart,np        
          ax(i) = 0.
          ar(i) = 0.
      enddo
    
       do lx=1,ncx !1
         j1 = lx 
         
         if(nc(j1,2).gt.0) then !2
c                            ! if the cell is not empty, then
c                            ! loop over it and over neighboring
c                            ! cells


c          -- Cells in the same XY sheet -
           lx2 = lx+1
           if(lx2.le.ncx)then
             call celij(j1,j1+1)     !East
           endif      

         endif    !End of:  if(nc(j1,kind_p1).gt.0) then
       
       enddo !1
       
       do j1=1,nct
           if(nc(j1,2).gt.0)
     +		call self(j1)
       enddo
       
       do i=nstart,np
       
c        -- calculating position of particle i --
           dxx = xp(i) - xmin
           j1 = int( dxx*one_over_2hmax ) + 1
       
           if(j1.lt.ncx)then
              call celij_ob(i,j1,j1+1) 
           endif 
           
           if(j1.gt.1)then
              call celij_ob(i,j1,j1-1) 
           endif 
           
           call celij_ob(i,j1,j1)   
         
     
       enddo
       
       return
       end

