c Copyright (c) 2013, Dr Renato Vacondio, Dr Benedict Rogers, Prof. Peter Stansby 
c and Prof. Paolo Mignosa
c 
c All rights reserved.
c 
c This file is part of SWE-SPHYSICS.
c 
c Redistribution and use in source and binary forms, with or without modification, 
c are permitted provided that the following conditions are met:
c 
c - Redistributions of source code must retain the above copyright notice, 
c  this list of conditions and the following disclaimer.
c - Redistributions in binary form must reproduce the above copyright notice, 
c  this list of conditions and the following disclaimer in the documentation 
c  and/or other materials provided with the distribution.
c
c THE "SWE-SPHYSICS" IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
c ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
c OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
c THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
c SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
c OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
c HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR 
c TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
c EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
c
c calculating alphap, grad_dw and grad_up
c

      subroutine ac_alpha
c
      use global_1D

      integer i, lx, j1, lx2 
      real dxx

c        -- Zeroing Variables --         
      do i=nstart,np
          alphap(i) = 0. !alpha
          grad_up(i)=0.  ! velocity gradient
      enddo
                   
       do lx=1,ncx
          j1 = lx 
         
          if(nc(j1,2).gt.0) then

             lx2 = lx+1
             if(lx2.le.ncx)then
                call celij_alpha(j1,j1+1)     !East
             endif      
      
          endif 
       
       enddo
       
       do j1=1,nct
           if(nc(j1,2).gt.0)
     +		call self_alpha(j1)
       enddo

       do i=1,np       
c        -- calculating position of particle i --
           dxx = xp(i) - xmin
           j1 = int( dxx*one_over_2hmax ) + 1
       
           if(j1.lt.ncx)then
              call celij_alpha_ob(i,j1,j1+1) 
           endif 
           
           if(j1.gt.1)then
              call celij_alpha_ob(i,j1,j1-1) 
           endif         
       
           call celij_alpha_ob(i,j1,j1)  
       enddo
       
c -- alpha for ghost partcles --
       do i=np_fixed+1,np
          alphap(i)=alphap( ighost(i) )
          h_var(i)=h_var( ighost(i) )
          rhop(i)=rhop( ighost(i) )
          dw(i)=dw( ighost(i) )
       enddo	
              
       return
       
       end

