c Copyright (c) 2013, Dr Renato Vacondio, Dr Benedict Rogers, Prof. Peter Stansby 
c and Prof. Paolo Mignosa
c 
c All rights reserved.
c 
c This file is part of SWE-SPHYSICS.
c 
c Redistribution and use in source and binary forms, with or without modification, 
c are permitted provided that the following conditions are met:
c 
c - Redistributions of source code must retain the above copyright notice, 
c  this list of conditions and the following disclaimer.
c - Redistributions in binary form must reproduce the above copyright notice, 
c  this list of conditions and the following disclaimer in the documentation 
c  and/or other materials provided with the distribution.
c
c THE "SWE-SPHYSICS" IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
c ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
c OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
c THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
c SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
c OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
c HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR 
c TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
c EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

c subroutine for bottom elevation of fluid particles using SPH interpolation     
      subroutine bottom
      use global_1D

      integer i, j1
      real dxx 
     
      do i=1,np

c        -- Zeroing Variables --         
          h_t(i)=0
          sum_h_t(i)=0

      enddo
      
      do i=1,np_fixed
         if (iflag(i).ne.0) then
c        -- calculating position of particle i --
             dxx = xp(i) - xminb
             j1 = int( dxx/(2*hsm_b) ) + 1
      
             if (j1.lt.ncx_b) then
                 call celij_hb(i,j1,j1+1)
             endif

             if (j1.gt.1) then
                 call celij_hb(i,j1,j1-1)
             endif
             !the same subroutine also for the cell itself
             call celij_hb(i,j1,j1)
             
             !shepard correction
             h_t(i)=h_t(i)/sum_h_t(i)
         endif
      enddo
            
      end
