c Copyright (c) 2013, Dr Renato Vacondio, Dr Benedict Rogers, Prof. Peter Stansby 
c and Prof. Paolo Mignosa
c 
c All rights reserved.
c 
c This file is part of SWE-SPHYSICS.
c 
c Redistribution and use in source and binary forms, with or without modification, 
c are permitted provided that the following conditions are met:
c 
c - Redistributions of source code must retain the above copyright notice, 
c  this list of conditions and the following disclaimer.
c - Redistributions in binary form must reproduce the above copyright notice, 
c  this list of conditions and the following disclaimer in the documentation 
c  and/or other materials provided with the distribution.
c
c THE "SWE-SPHYSICS" IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
c ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
c OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
c THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
c SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
c OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
c HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR 
c TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
c EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

      subroutine celij_alpha(j1,j2)
c
      use global_1D  
	 
      integer j1, j2, i, j, ii, jj
      real drx, rr2

        if(nc(j2,2).ne.0) then !2

        do ii=1,nc(j1,2) !3
          i = ibox(j1,2,ii)
         
          do jj=1,nc(j2,2) !4
           j = ibox(j2,2,jj)

            drx = xp(i) - xp(j)
            rr2 = drx*drx

! --- i-particle ---
	    if( ( rr2.lt.( 4*h_var(i)*h_var(i) ) )
     + .and.rr2.gt.1.e-18) then !5  

	         !call kernel(drx,rr2,i)
                 call kernel(const_ker,drx,h_var(i),frx,fac,Wab)  
 
                alphap(i)=alphap(i)-sqrt(rr2)*pm(j)*fac
                 
                grad_up(i)=grad_up(i)
     +                    +(pm(j)/rhop(j))*(up(j)-up(i))*frx !/sum_frx(i)  !gradient of velocity

                grad_dw(i)=grad_dw(i)
     +                    +(pm(j)/rhop(j))*(dw(j)-dw(i))*frx !/sum_frx(i)  !gradient of water depth
     
            endif
	    
! --- j-particle ---
            if( ( rr2.lt.( 4*h_var(j)*h_var(j) ) )
     + .and.rr2.gt.1.e-18) then !5  

	         !call kernel(-drx,rr2,j)
                 call kernel(const_ker,-drx,h_var(j),frx,fac,Wab)    
                 
                 alphap(j)=alphap(j)-sqrt(rr2)*pm(i)*fac
                 
                 grad_up(j)=grad_up(j)
     +                     +(pm(i)/rhop(i))*(up(i)-up(j))*frx !/sum_frx(j)  !gradient of velocity

                 grad_dw(j)=grad_dw(j)
     +                     +(pm(i)/rhop(i))*(dw(i)-dw(j))*frx !/sum_frx(j)  !gradient of water depth
     

            endif

         enddo   !4
        enddo !3
	 endif !2

      end
