c Copyright (c) 2013, Dr Renato Vacondio, Dr Benedict Rogers, Prof. Peter Stansby 
c and Prof. Paolo Mignosa
c 
c All rights reserved.
c 
c This file is part of SWE-SPHYSICS.
c 
c Redistribution and use in source and binary forms, with or without modification, 
c are permitted provided that the following conditions are met:
c 
c - Redistributions of source code must retain the above copyright notice, 
c  this list of conditions and the following disclaimer.
c - Redistributions in binary form must reproduce the above copyright notice, 
c  this list of conditions and the following disclaimer in the documentation 
c  and/or other materials provided with the distribution.
c
c THE "SWE-SPHYSICS" IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
c ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
c OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
c THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
c SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
c OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
c HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR 
c TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
c EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

      subroutine celij_ob(i,j1,j2)

      use global_1D

      integer j1, j2, i, j, jj
      real drx, rr2, dux, rdw_l, rdw_r, rup_l, rup_r, 
     + rcs_l, rcs_r, p_ast, betai, betaj, p_v, dot2
	 
        if(nc(j2,3).ne.0) then !1
         
          do jj=1,nc(j2,3) !2
           j = ibox(j2,3,jj)

            drx = xp(i) - xp_ob(j)
            rr2 = drx*drx
            dux = up(i) - up_ob(j) 

c ---  no reconstruction of water depth at interface
            rdw_l=dw_ob(j)
            rdw_r=dw(i)
            
c ---  no reconstruction of velocity at the interface
            rup_l=up_ob(j)
            rup_r=up(i)
           
            rcs_l=sqrt(grav*rdw_l)
            rcs_r=sqrt(grav*rdw_r)  

            if (drx.gt.0) then
            call balsara( p_ast,rdw_l,rdw_r, rup_l,rup_r, rcs_l, rcs_r )    
            else
            call balsara( p_ast,rdw_r,rdw_l, rup_r,rup_l, rcs_r, rcs_l )
            endif 

! --- frx i-particle ---
	    if( ( rr2.lt.( 4*h_var(i)*h_var(i) ) ) !3
     + .and.rr2.gt.1.e-18) then 
     
                call kernel(const_ker,drx,h_var(i),frx,fac,Wab)
     
                betai=rhop(i)*dm/alphap(i)
                p_v= betai/( rhop(i)*rhop(i) )
                  
                ax(i)= ax(i) - pm_ob(j)*p_ast*p_v*frx
                
                dot2 = - dux*frx
                ar(i) = ar(i) + pm_ob(j)*dot2 !density acc
          
	      endif !3
	      
! --- frx j-particle ---
            if( ( rr2.lt.( 4*h_var(i)*h_var(i) ) )
     + .and.rr2.gt.1.e-18) then !5 
     
	        call kernel(const_ker,-drx,h_var(i),frx,fac,Wab)

                betaj=dw_ob(j)*rho0*dm/alphap_ob(j)
                p_v= betaj/( rhop_ob(j)*rhop_ob(j) )
                  
                ax(i)= ax(i) + pm_ob(j)*p_ast*p_v*frx
               
            endif   	      
	      
         enddo   !2
	endif !1

      end
