c Copyright (c) 2013, Dr Renato Vacondio, Dr Benedict Rogers, Prof. Peter Stansby 
c and Prof. Paolo Mignosa
c 
c All rights reserved.
c 
c This file is part of SWE-SPHYSICS.
c 
c Redistribution and use in source and binary forms, with or without modification, 
c are permitted provided that the following conditions are met:
c 
c - Redistributions of source code must retain the above copyright notice, 
c  this list of conditions and the following disclaimer.
c - Redistributions in binary form must reproduce the above copyright notice, 
c  this list of conditions and the following disclaimer in the documentation 
c  and/or other materials provided with the distribution.
c
c THE "SWE-SPHYSICS" IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
c ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
c OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
c THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
c SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
c OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
c HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR 
c TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
c EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

      subroutine celij(j1,j2)

      use global_1D

      integer j1, j2, ii, jj, i, j
      real drx, rr2, dux, dot, rhobar, one_over_rhobar, cbar, hbar 
      real r_lim, rup_l, rup_r, fi, betai, betaj, p_v, pi_visc, dot2
	 
      if(nc(j2,2).ne.0) then !2

        do ii=1,nc(j1,2) !3
          i = ibox(j1,2,ii)
         
          do jj=1,nc(j2,2) !4
           j = ibox(j2,2,jj)
           
            drx = xp(i) - xp(j)
            rr2 = drx*drx 
            dux = up(i) - up(j)
            
c ---  MUSCL reconstruction of velocity at interface
                  
            if (abs(dux).gt.0.00001) then         
                r_lim=( grad_up(j)*drx )/dux  
            else
              r_lim=10
            endif
            call limiter(r_lim,fi)
            rup_l=up(j)+0.5*fi*dux 
            
            if (abs(dux).gt.0.00001) then    
                  r_lim=( grad_up(i)*drx )/dux 
            else
              r_lim=10
            endif
            call limiter(r_lim,fi)
            rup_r=up(i)-0.5*fi*dux 
             
            dot=drx*(rup_r-rup_l)
            rhobar  = 0.5*rho0*( dw(i) + dw(j) )
            one_over_rhobar = 1/rhobar
            cbar = max( cs(i)+abs(up(i)), cs(j)+abs(up(j)) )
	    hbar = 0.5*( h_var(i)+h_var(j) )

! --- frx i-particle ---
	    if( ( rr2.lt.( 4*h_var(i)*h_var(i) ) )
     + .and.rr2.gt.1.e-18) then !5  !RV: modified (h_var)

                !call kernel(drx,h_var(i),frx,Wab)
                call kernel(const_ker,drx,h_var(i),frx,fac,Wab)

                betai=rhop(i)*dm/alphap(i)
                p_v= 0.5*betai*grav/rho0
                
	     call viscosity(pi_visc,dot,drx,dux,2,rr2,
     +                  cbar,rhobar,one_over_rhobar,hbar)
                  
                ax(i)= ax(i) - pm(j)*(p_v+0.5*pi_visc)*(frx) !artificial viscosity
                ax(j)= ax(j) + pm(i)*(p_v+0.5*pi_visc)*(frx)                

                 !density acc
                 dot2 = + dux*frx
                 ar(i) = ar(i) + (pm(j)/rhop(j))*dot2 !density acc

            endif
	    
! --- frx j-particle ---
            if( ( rr2.lt.( 4*h_var(j)*h_var(j) ) )
     + .and.rr2.gt.1.e-18) then !5  

	         !call kernel(-drx,h_var(j),frx,Wab) 
                 call kernel(const_ker,-drx,h_var(j),frx,fac,Wab)

                 betaj=rhop(j)*dm/alphap(j)
                 p_v= 0.5*betaj*grav/rho0

	     call viscosity(pi_visc,dot,drx,dux,2,rr2,
     +                  cbar,rhobar,one_over_rhobar,hbar)
                  
                ax(i)= ax(i) + pm(j)*(p_v+0.5*pi_visc)*(frx)
                ax(j)= ax(j) - pm(i)*(p_v+0.5*pi_visc)*(frx)

                 dot2 = -dux*frx
                 ar(j) = ar(j) + (pm(i)/rhop(i))*dot2  !density acc

            endif

         enddo   !4
        enddo !3
	 endif !2
c	enddo !1

      end
