c Copyright (c) 2013, Dr Renato Vacondio, Dr Benedict Rogers, Prof. Peter Stansby 
c and Prof. Paolo Mignosa
c 
c All rights reserved.
c 
c This file is part of SWE-SPHYSICS.
c 
c Redistribution and use in source and binary forms, with or without modification, 
c are permitted provided that the following conditions are met:
c 
c - Redistributions of source code must retain the above copyright notice, 
c  this list of conditions and the following disclaimer.
c - Redistributions in binary form must reproduce the above copyright notice, 
c  this list of conditions and the following disclaimer in the documentation 
c  and/or other materials provided with the distribution.
c
c THE "SWE-SPHYSICS" IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
c ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
c OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
c THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
c SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
c OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
c HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR 
c TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
c EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

      module global_1D

      integer, parameter :: npar=7000,nb_max=400
      integer, parameter:: nct_max=3000,nplink_max=500

c      common /ccloc/ np,xp(npar),zp(npar),up(npar), 
c     1               wp(npar),rhop(npar),pm(npar),cs(npar)

      real xp(npar), up(npar), rhop(npar), pm(npar), cs(npar), 
     + areap(npar)

      integer np 

c      common /cctime/ time,tmax,out,trec_ini,ivar_dt,itime

      real time, tmax, out, trec_ini
      integer ivar_dt,itime

c      common /detailed/dtrec_det,t_sta_det,t_end_det     
              
c      common /bcs/   D,r0,ip1,ip2,nb,nbp1,
c     1               nb1,nb2,nb3

      integer nb, nbp1
 
c      common /fast/  xmin,xmax,zmin,zmax,ncx,ncz,nct,nc(nct_max,3)   

      real xmin, xmax 
      integer ncx, nct, nc(nct_max,3)

c      common /kern/  h,hh(3),c1(3),d1(3),c2(3),a1,a2(3),a24(3),f1(3),
c     1               b1(3),e1(3),aa,pi,twopi,od_Wdeltap(3),h2(3),
c     2               fourh2(3),hh_x(3),hh_z(3),
c     3               twoh_x(3),twoh_z(3),Awen(3),Bwen(3),
c     4               one_over_2h,one_over_h,two_h,four_h,six_h
c      common /cvis/  viscos_val,eta,eta2,visc_wall

      real h, pi, twopi, eta, eta2, viscos_val, const_ker(2)
      integer iMUSCL, i_dw_iter,  i_max_iter


c      common /state/ B,gamma,rho0,cs0,i_gamma,h_SWL,i_EoS,
c     1               one_over_beta_coef2,one_over_beta_coef

      real rho0
     
c      common /damp/  gg,damp
c      common /xsph/  xcor(npar),zcor(npar),eps
c      common /body/  grx,grz,thetam,omega,gx,stheta,orig
c      common /wbc/   mw1,mw2,xamp,xfreq,h0,xorig(npar),
c     1               iwmcase

      real h0

c      common /newac/ ax(npar),az(npar),ar(npar),
c     1               ux(npar),wx(npar),zx(npar)

      real ax(npar), ar(npar)
c      common /val_kernel/ sum_wab(npar),Wab,frx,
c     1                   frz,fac

      real sum_wab(npar), Wab, frx, fac

c      common /marching/ ncall1,ncall2,ncall3,ncall4,ncall5,ncall6,
c     1                  ncall7,ncall8,ncall9,ncall10
c      common /CSPH/ dudx_CSPH(npar),dudz_CSPH(npar),
c     1              dwdx_CSPH(npar),dwdz_CSPH(npar)
c      common /SPS/   twoThirds,blin_const,Smag,dp,dx,dy,dz,
c     1              tau_xx_uno_rho2(npar),tau_xz_uno_rho2(npar),
c     2              tau_zz_uno_rho2(npar),
c     3              visc_SPS_max,
c     4              curl3y_a(npar),curl3y_b(npar),
c     5              sum_dWdx(npar),sum_dWdz(npar)
c      common /vorticity/ ivort_calc,vorty(npar),
c     2               vortmin,vortmax,densitymin,densitymax				
c      common /verlet/ xm1(npar),zm1(npar),rhom1(npar),
c     1                um1(npar),wm1(npar),dtsq,TEm1(npar),kk_verlet
c      common /density_filter/ i_DensityFilter,index_tensile,adh,
c     1                        pVol(npar),n_dt_FilterPerform
c      common /BP_Normals/ iBC,nstart,nstart_minus1

      integer iBC, nstart, nstart_minus1

c     1                 xnb(nb_max),znb(nb_max),
c     2                 xtb(nb_max),ztb(nb_max),
c     3                 deltaptb(nb_max,2)
c      common /BP_normalInfo/
c     1           iBP_Pointer_Info(nb_max,4), BP_xz_Data(nb_max,2)
c      common /periodicBCs/ i_periodicOBs(3)
c      common /dimension/ iDIM,idim_coef
c      common /mobilgate/ iopt_gate,ngate_ini,ngate_end,
c     1                   VXgate,VZgate
c      common /wave_maker/ iopt_wavemaker,i_paddleType,
c     1                   nwavemaker_ini,Xwavemaker,
c     2                   nwavemaker_end,Nfreq,ind_wm,ind1_wm,
c     3                   Period(0:1000),A_wavemaker(0:1000),
c     4                   phase(0:1000),twinitial(0:1000),
c     5                   flap_length, paddle_SWL,stroke,
c     6                   X_PaddleCentre,xp_ini(nb_max)
c      common /RaichlenWedge_Vars/ iopt_RaichlenWedge,
c     1                 bslope,i_RBend,RBtime(1000),RBxpos(1000),
c     2                 xp_Wedge_initial(nb_max),
c     3                 zp_Wedge_initial(nb_max)
c      common /mobilparticles/ nbf,nbfp1,iopt_movingObject
c      common /keeplist/ keep_nc(nct_max)
c      common /compiling_options/i_viscos,i_kernel,i_algorithm
c      common /time_step/ dt,dt_new,dt_old

      real dt, dt_new, dt_old, grab_P, dt_max 
      integer nbfp1

c      common /container/xmax_container,xmin_container,
c     1                 zmin_container,iflag(npar),
c     2                 xtrash,ztrash,nct_ini,zmax_ini,
c     4                 ncz_ini,zcontrol

      real xmax_container, xmin_container, xtrash
      integer iflag(npar)


c      common /geometry/ i_geometry,vlx1,vlx2,vlx,vlz

      real vlx
  
c      common /fluidgrid/ lattice,vnorm_mass
c      common /restartruns/ngrab,grab_P,grab_E,i_restartRun
c      common /iboxtemp/ ibox(nct_max,3,nplink_max)

      integer ibox(nct_max,3,nplink_max), i_restartRun, ngrab

c      common /MovingLeastSquares/ nstart_MLS,i_MLS_part,
c     1      beta0_MLS(npar),beta1x_MLS(npar),beta1z_MLS(npar),
c     2      rhop_sum_MLS(npar),A_MLS(npar,3,3)
c      common /SWE/ dw(npar), dwo(npar), dw0(npar), CFL, np_fixed

      real dw(npar), dw0(npar), CFL
      integer np_fixed

c      common /SWE2/ xlim_left, xlim_right, h_var(npar),h_var0(npar),
c     1 hmax, one_over_2hmax, dm

      real xlim_left, xlim_right, h_var(npar),h_var0(npar),
     1 hmax, one_over_2hmax, dm

c      common /SWE3/ alphap(npar), alphapo(npar), tol,
c     1 rhop_sum, grav,sum_alpha(npar),ighost(npar),Res_adm(npar),
c     2 n_assign,uo(npar),udot(npar)

      real alphap(npar), tol, rhop_sum, grav,
     1 sum_alpha(npar),Res_adm(npar), uo(npar), udot(npar)

      integer ighost(npar), n_assign

c      common /SWE4/ h_t(npar),dh_t(npar),ddh_t(npar),t_st(npar),
c     1 ax_old(npar)

      real h_t(npar),dh_t(npar),ddh_t(npar),t_st(npar), ax_old(npar)

c      common /SWE5/ dH_SPH(npar),ddH_SPH(npar), diff_udot(npar), itest

      real dH_SPH(npar),ddH_SPH(npar), diff_udot(npar), sum_b_f(npar)
      integer itest


c      common /BOT/ xb(npar), hb(npar),np_b,dxb, hsm_b, xmaxb,xminb 

      real  xb(npar), hb(npar),dxb, hsm_b, xmaxb,xminb 
      integer np_b

c      common /BOT2/ nct_b,ncx_b, iboxb(nct_max,nplink_max),ncb(nct_max),
c     1 sum_h_t(npar)
c      common /KCORR/ sum_frx(npar)

      real sum_h_t(npar), sum_frx(npar)
      integer nct_b, ncx_b, iboxb(nct_max,nplink_max), ncb(nct_max)

c MUSCL reconstruction 
c      common /MUSCL/ grad_dw(npar), grad_up(npar), grad_upu, sum_frxu 

      real grad_dw(npar), grad_up(npar), grad_upu, sum_frxu

c OPENBC
c      common /OPENBC/ xpbc(2),pmbc(2),h_varbc(2),iflagbc(2),
c     1 dwbc(2), upbc(2), verbc(2), if_openbc, xmax_ob, xmin_ob,
c     2 hmax_ob, dw0bc(2),dxobc(2)

      real xpbc(2),pmbc(2),h_varbc(2), dwbc(2), upbc(2), verbc(2), 
     1 xmax_ob, xmin_ob, hmax_ob, dw0bc(2),dxobc(2)

      integer iflagbc(2), if_openbc, idebug

c      common /OPENBC2/ upi(npar), uoi(npar), dwi(npar), ib(npar),np_ob

      real upi(npar), uoi(npar), dwi(npar)
      integer ib(npar),np_ob

c      common /OPENBC3/ xp_ob(npar),pm_ob(npar),h_var_ob(npar),
c     1 dw_ob(npar),up_ob(npar),dwo_ob(npar), rhop_ob(npar),cs_ob(npar),
c     2 alphap_ob(npar),alphapo_ob(npar), iflag_ob(npar), uo_ob(npar),
c     3 dw0_ob(npar), h_var0_ob(npar)

      real xp_ob(npar),pm_ob(npar),h_var_ob(npar), dw_ob(npar),
     1 up_ob(npar), rhop_ob(npar),cs_ob(npar), alphap_ob(npar),
     2 uo_ob(npar), dw0_ob(npar), h_var0_ob(npar)

      integer iflag_ob(npar)

c well balanced formulation
c      common /WELL/ eta0(npar), pm_eta(npar), rhop_eta(npar),
c     1  dH_SPH_well(npar), eta_as

      end module
      
      
      
